#!/usr/bin/perl -w

use strict;

my $file = '';

if($ARGV[0]) {
	$file = $ARGV[0];
	if(!-r $file && !-w $file) {
		print "Error: Cannot read and/or write file: $file\n";
		exit 1;
	}
}
else {
	print "Usage: rewrite-code.pl <file>\n";
	exit 1;
}

open(F, $file) || die "Error: Cannot open file: $file ($!)";
while(<F>) {
	# this.lblIndex0GeneralStatusCollon.Location = new System.Drawing.Point(86, 15);
	# this.lblIndex0GeneralStatusText.Location = new System.Drawing.Point(6, 15);
	# this.lblIndex0GeneralStatusValue.Location = new System.Drawing.Point(102, 15);
	# 
	# this.lblIndex0GeneralProjectCollon.Location = new System.Drawing.Point(86, 28);
	# this.lblIndex0GeneralProjectText.Location = new System.Drawing.Point(6, 28);
	# this.lblIndex0GeneralProjectValue.Location = new System.Drawing.Point(102, 28);
	# 
	# 
	# this.lblIndex1GeneralStatusCollon.Location = new System.Drawing.Point(86, 28);
	# this.lblIndex1GeneralStatusText.Location = new System.Drawing.Point(6, 28);
	# this.lblIndex1GeneralStatusValue.Location = new System.Drawing.Point(102, 28);
	#             
	# this.lblIndex1GeneralProjectCollon.Location = new System.Drawing.Point(86, 15);
	# this.lblIndex1GeneralProjectText.Location = new System.Drawing.Point(6, 15);
	# this.lblIndex1GeneralProjectValue.Location = new System.Drawing.Point(102, 15);
            
	if(/^(\s*this.lblIndex[0-9]General)(Status|Project)(Collon|Text|Value)(.Location = new System.Drawing.Point\()(\d+, \d+)(\);\s*)$/) {
		my $p = $5;
		if($p eq '86, 15') {
			# StatusCollon	 86,15 ->  86,28
			$p = '86, 28';
		}
		elsif($p eq '6, 15') {
			# StatusText	  6,15 ->   6,28
			$p = '6, 28';
		}
		elsif($p eq '102, 15') {
			# StatusValue	102,15 -> 102,28
			$p = '102, 28';
		}
		elsif($p eq '86, 28') {
			# ProjectCollon	 86,28 ->  86,15
			$p = '86, 15';
		}
		elsif($p eq '6, 28') {
			# ProjectText	  6,28 ->   6,15
			$p = '6, 15';
		}
		elsif($p eq '102, 28') {
			# ProjectValue	102,28 -> 102,15
			$p = '102, 15';
		}

		print $1.$2.$3.$4.$p.$6;
	}
	else {
		print;
	}
}
close F;
